//----------------------------------------------------------------------//
// NyanFi																//
//  \[g_CAO													//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "Global.h"
#include "UserFunc.h"
#include "SrtModDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSortModeDlg *SortModeDlg;

//---------------------------------------------------------------------------
__fastcall TSortModeDlg::TSortModeDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::FormCreate(TObject *Sender)
{
	set_ComboBoxText(DirSortModeComboBox,
		_T("t@CƓ\nO\nXV\nTCY\n\nfBNgʂȂ\n"));
}
//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	int hi = ModePanel->Height + BtnPanel->Height;
	if (ScrMode==SCMD_IVIEW) {
		DirSortModeGroupBox->Visible = false;
		SortBothCheckBox->Visible	 = false;

	}
	else {
		DirSortModeGroupBox->Visible = true;
		SortBothCheckBox->Visible	 = true;
		hi += DirOptPanel->Height;
	}
	ClientHeight = hi;

	Changed  = false;
	SelByKey = false;
	InhOk	 = true;

	Caption = "\[g - " + get_LRUD_str(CurListTag, SortBoth);

	NaturalCheckBox->Checked	   = NaturalOrder;
	DscNameCheckBox->Checked	   = DscNameOrder;
	OldCheckBox->Checked		   = OldOrder;
	SmallCheckBox->Checked		   = SmallOrder;
	DscAttrCheckBox->Checked	   = DscAttrOrder;
	SortBothCheckBox->Checked	   = SortBoth;
	SortModeRadioGroup->ItemIndex  = SortMode[CurListTag];
	DirSortModeComboBox->ItemIndex = DirSortMode[CurListTag];
	SortModeRadioGroup->SetFocus();

	this->Perform(WM_NEXTDLGCTL, 0, 0);
	InhOk = false;
}
//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);

	if (ModalResult==mrOk) {
		NaturalOrder = NaturalCheckBox->Checked;
		DscNameOrder = DscNameCheckBox->Checked;
		OldOrder	 = OldCheckBox->Checked;
		SmallOrder	 = SmallCheckBox->Checked;
		DscAttrOrder = DscAttrCheckBox->Checked;
		SortBoth	 = SortBothCheckBox->Checked;

		int s_mode = SortModeRadioGroup->ItemIndex;
		int d_mode = DirSortModeComboBox->ItemIndex;
		SortMode[CurListTag]	= s_mode;
		DirSortMode[CurListTag] = d_mode;

		if (SortBoth) {
			SortMode[OppListTag]	= s_mode;
			DirSortMode[OppListTag] = d_mode;
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::SortBothCheckBoxClick(TObject *Sender)
{
	Caption = "\[g - " + get_LRUD_str(CurListTag, SortBothCheckBox->Checked);
}

//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::SortModeRadioGroupClick(TObject *Sender)
{
	if (!InhOk) {
		Changed = true;
		if (SortModeRadioGroup->Enabled) ModalResult = mrOk;
	}
	else InhOk = false;
}
//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::OptCheckBoxClick(TObject *Sender)
{
	Changed = true;
}

//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (SpecialKeyProc(this, Key, Shift, _T(HELPTOPIC_FL) _T("#SortDlg"))) return;

	if (Shift.Empty()) {
		int idx = -1;
		switch (Key) {
		case 'F': idx = 0; break;
		case 'E': idx = 1; break;
		case 'D': idx = 2; break;
		case 'S': idx = 3; break;
		case 'A': idx = 4; break;
		}
		if (SortModeRadioGroup->Enabled && idx==SortModeRadioGroup->ItemIndex) {
			SelByKey = true;	//݂̃[h̃L[ꂽ
			Key = 0;
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::SortModeRadioGroupEnter(TObject *Sender)
{
	if (SortModeRadioGroup->Enabled && SelByKey)
		ModalResult = Changed? mrOk : mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TSortModeDlg::SortModeRadioGroupExit(TObject *Sender)
{
	SelByKey = false;
}
//---------------------------------------------------------------------------

